(ns bombnet.core
  (:gen-class)
  (:require [com.stuartsierra.component :as component]
            [bombnet.server :refer :all]))

(defn new-system []
  (component/system-map
    :server (new-server)))

(def system nil)

(defn init []
  (alter-var-root #'system
    (constantly (new-system))))

(defn start []
  (alter-var-root #'system component/start))

(defn stop []
  (alter-var-root #'system
    (fn [s] (when s (component/stop s)))))

(defn go []
  (init)
  (start))

(defn reset []
  (stop)
  (init)
  (start))

(defn -main
  "Run the server"
  [& args]
  (go))
